var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var import_fs = __toESM(require("fs"));
var import_path = __toESM(require("path"));
const distFolder = __dirname;
const scripts = {
  "react-render-tracker": import_path.default.join(distFolder, "react-render-tracker.js"),
  "data-client": import_path.default.join(distFolder, "data-client.js")
};
function readScript(name) {
  return import_fs.default.readFileSync(scripts[name], "utf8");
}
function readScriptWithExports(name) {
  const exportSymbols = [];
  const source = readScript(name).replace(/export\s*(\{(.|\s)+?\})/, (_, e) => "const api=" + e.replace(/([a-z]+) as ([a-z]+)/gi, (_2, localName, exportName) => {
    exportSymbols.push(exportName);
    return `${exportName}:${localName}`;
  }) + ";return api.isReady().then(()=>api)");
  return {
    source,
    exportSymbols
  };
}
async function initDataClient(page) {
  const dataClient = /* @__PURE__ */ Object.create(null);
  const module2 = readScriptWithExports("data-client");
  const dataClientHandle = await page.evaluateHandle(new Function(module2.source));
  for (const name of module2.exportSymbols) {
    dataClient[name] = (...args) => dataClientHandle.evaluate((client, { name: name2, args: args2 }) => client[name2](...args2), { name, args });
  }
  return dataClient;
}
module.exports = async function newPageDataClient(page) {
  let pageSessionDataClient;
  const addInitScript = "addInitScript" in page ? page.addInitScript : page.evaluateOnNewDocument;
  addInitScript.call(page, readScript("react-render-tracker"));
  page.on("framenavigated", () => {
    pageSessionDataClient = initDataClient(page);
  });
  const client = /* @__PURE__ */ Object.create(null);
  const { exportSymbols } = readScriptWithExports("data-client");
  for (const method of exportSymbols) {
    client[method] = async (...args) => (await pageSessionDataClient)[method](...args);
  }
  return client;
};
