import { fileURLToPath } from "url";
const __dirname = path.dirname(fileURLToPath(import.meta.url));

var __getOwnPropNames = Object.getOwnPropertyNames;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
import fs from "fs";
import path from "path";
var require_headless_browser = __commonJS({
  "src/data-client/headless-browser.ts"(exports, module) {
    const distFolder = __dirname;
    const scripts = {
      "react-render-tracker": path.join(distFolder, "react-render-tracker.js"),
      "data-client": path.join(distFolder, "data-client.js")
    };
    function readScript(name) {
      return fs.readFileSync(scripts[name], "utf8");
    }
    function readScriptWithExports(name) {
      const exportSymbols = [];
      const source = readScript(name).replace(/export\s*(\{(.|\s)+?\})/, (_, e) => "const api=" + e.replace(/([a-z]+) as ([a-z]+)/gi, (_2, localName, exportName) => {
        exportSymbols.push(exportName);
        return `${exportName}:${localName}`;
      }) + ";return api.isReady().then(()=>api)");
      return {
        source,
        exportSymbols
      };
    }
    async function initDataClient(page) {
      const dataClient = /* @__PURE__ */ Object.create(null);
      const module2 = readScriptWithExports("data-client");
      const dataClientHandle = await page.evaluateHandle(new Function(module2.source));
      for (const name of module2.exportSymbols) {
        dataClient[name] = (...args) => dataClientHandle.evaluate((client, { name: name2, args: args2 }) => client[name2](...args2), { name, args });
      }
      return dataClient;
    }
    module.exports = async function newPageDataClient(page) {
      let pageSessionDataClient;
      const addInitScript = "addInitScript" in page ? page.addInitScript : page.evaluateOnNewDocument;
      addInitScript.call(page, readScript("react-render-tracker"));
      page.on("framenavigated", () => {
        pageSessionDataClient = initDataClient(page);
      });
      const client = /* @__PURE__ */ Object.create(null);
      const { exportSymbols } = readScriptWithExports("data-client");
      for (const method of exportSymbols) {
        client[method] = async (...args) => (await pageSessionDataClient)[method](...args);
      }
      return client;
    };
  }
});
export default require_headless_browser();
